<?php namespace CodeSpace\Wiki;

class DataSource {

	private string $docs_path;

	public function __construct() {
		$this->docs_path = realpath("../docs/");
	}

	public function getMarkdown(string $file): ?string {
		$markdown = file_get_contents($file);
		return $markdown ?? null;
	}

	public function getMenu(string $file): ?array {
		$path = dirname($file);
		while (strlen($this->docs_path) <= strlen($path)) {
			$menu_file = "$path/menu.json";
			if (file_exists($menu_file)) {
				$data = file_get_contents($menu_file);
				return $data ? json_decode($data, true) : null;
			}
			$path = dirname($path);
		}
		return null;
	}

	public function getFile(string $slug): string {
		if (!$slug) $slug = "index";
		$files = [
			"$this->docs_path/$slug.md",
			"$this->docs_path/$slug/index.md"
		];
		foreach ($files as &$file) {
			if (file_exists($file)) return $file;
		}
		return $files[1];
	}

}